/*
EXAMPLE.PRG
Applies Structural Break Tests and P-Value Computations

Bruce E. Hansen
Department of Economics
Social Science Building
University of Wisconsin
Madison, WI 53706-1393
bhansen@ssc.wisc.edu
http://www.ssc.wisc.edu/~bhansen/


*/

#include st_ch.prc;
output file = example.out reset;

ar = 6;
t=595;
load dat[t+2,1]=gmpy.db;
d=dat[3:t+2];
d=ln(d);
dy=d[2:t]-d[1:t-1];
y=dy[1+ar:t-1];
x=ones(t-1-ar,1);
i=1;do while i<=ar;
 x=x~dy[1+ar-i:t-1-i];
i=i+1;endo;
{k,supf,expf,avef}=st_ch(y,x,.15,.85,1);
"Monthly Personal Income";
"Sample Period " dat[1 2]';
"AR(6) Model";
"";
stat=supf[1,.]|expf[1,.]|avef[1,.];
let fmt[1,3] = "%*.*lf" 16 8;
let names = "SupLM" "ExpLM" "AveLM";
let tit[1,3] = "Test" "Stat" "P-Value";
p=printfm(tit,0~0~0,fmt);
"";
p=printfm(names~stat,0~1~1,fmt);
"";"";

ar = 12;
t=583;
load dat[t+2,1]=fygm3.db;
d=dat[3:t+2];
dy=d[2:t]-d[1:t-1];
y=dy[1+ar:t-1];
x=ones(t-1-ar,1);
i=1;do while i<=ar;
 x=x~dy[1+ar-i:t-1-i];
i=i+1;endo;
{k,supf,expf,avef}=st_ch(y,x,.15,.85,1);
"3-Month T-Bill Rate";
"Sample Period " dat[1 2]';
"AR(12) Model";
stat=supf[1,.]|expf[1,.]|avef[1,.];
let fmt[1,3] = "%*.*lf" 16 8;
let names = "SupLM" "ExpLM" "AveLM";
let tit[1,3] = "Test" "Stat" "P-Value";
p=printfm(tit,0~0~0,fmt);
"";
p=printfm(names~stat,0~1~1,fmt);
"";"";

output off;
